/* ÷
   LCD_init();
   LCD_write_string(,,"ַ");
   LCD_write_char(,,'ַ'); 
 ---------------------------------------------------------------
AVRLCDϢ
  PC6 ->RS
  PC7 ->EN
    ->RW
  PA4 ->D4
  PA5 ->D5
  PA6 ->D6
  PA7 ->D7
ʹö˿ڣ1602:PC6,PC7,PA4~PA7 	
ҪʹñıϢ
-----------------------------------------------------------------*/
#define LCD_EN_PORT    PORTC   //2ҪΪͬһ
#define LCD_EN_DDR     DDRC
#define LCD_RS_PORT    PORTC   //2ҪΪͬһ
#define LCD_RS_DDR     DDRC
#define LCD_DATA_PORT  PORTA   //3ҪΪͬһ
#define LCD_DATA_DDR   DDRA    //Ĭ߱ʹøλ˿,ע޸
#define LCD_DATA_PIN   PINA
#define LCD_RS         (1<<PC6) //0x20   portC6       out
#define LCD_EN         (1<<PC7) //0x40   portC7       out
#define LCD_DATA       ((1<<PA4)|(1<<PA5)|(1<<PA6)|(1<<PA7)) //0xf0   portA 4/5/6/7 out
/*--------------------------------------------------------------------------------------------------
˵
--------------------------------------------------------------------------------------------------*/
void LCD_init(void);
void LCD_en_write(void);
void LCD_write_command(unsigned  char command) ;
void LCD_write_data(unsigned char data);
void LCD_set_xy (unsigned char x, unsigned char y);
void LCD_write_string(unsigned char X,unsigned char Y,unsigned char *s);
void LCD_write_char(unsigned char X,unsigned char Y,unsigned char data);

//-----------------------------------------------------------------------------------------

#include <macros.h>
#include "delay.h"

void LCD_init(void)         //Һʼ
{
  LCD_DATA_DDR|=LCD_DATA;   //ݿڷΪ
  LCD_EN_DDR|=LCD_EN;       //ENΪ
  LCD_RS_DDR|=LCD_RS;       //RSΪ
  LCD_write_command(0x28); 
  LCD_en_write();
  delay_nus(100);
  LCD_write_command(0x28);  //4λʾ
  LCD_write_command(0x0c);  //ʾ
  LCD_write_command(0x01);  //
  delay_nms(10);
  LCD_write_string(0,0,"Light:       "); 
  delay_nms(10);
}

void LCD_en_write(void)  //Һʹ
{
  LCD_EN_PORT|=LCD_EN;
  delay_nus(10);
  LCD_EN_PORT&=~LCD_EN;
}

void LCD_write_command(unsigned char command) //дָ
{
  //Ϊ4λд
  delay_nus(16);
  LCD_RS_PORT&=~LCD_RS;        //RS=0
  LCD_DATA_PORT&=0X0f;         //λ
  LCD_DATA_PORT|=command&0xf0; //дλ
  LCD_en_write();
  command=command<<4;          //λƵλ
  LCD_DATA_PORT&=0x0f;         //λ
  LCD_DATA_PORT|=command&0xf0; //дλ
  LCD_en_write();
 
/*
  //Ϊλд
  delay_nus(16);
  LCD_RS_PORT&=~LCD_RS;        //RS=0
  LCD_DATA_PORT&=0xf0;         //λ
  LCD_DATA_PORT|=(command>>4)&0x0f; //дλ
  LCD_en_write();
  LCD_DATA_PORT&=0xf0;         //λ
  LCD_DATA_PORT|=command&0x0f; //дλ
  LCD_en_write(); 
*/
  
}

void LCD_write_data(unsigned char data) //д
{
  //Ϊ4λд
  delay_nus(16);
  LCD_RS_PORT|=LCD_RS;       //RS=1
  LCD_DATA_PORT&=0X0f;       //λ
  LCD_DATA_PORT|=data&0xf0;  //дλ
  LCD_en_write();
  data=data<<4;               //λƵλ
  LCD_DATA_PORT&=0X0f;        //λ
  LCD_DATA_PORT|=data&0xf0;   //дλ
  LCD_en_write();
  
/*
  //Ϊλд 
  delay_nus(16);
  LCD_RS_PORT|=LCD_RS;       //RS=1
  LCD_DATA_PORT&=0Xf0;       //λ
  LCD_DATA_PORT|=(data>>4)&0x0f;  //дλ
  LCD_en_write();
 
  LCD_DATA_PORT&=0Xf0;        //λ
  LCD_DATA_PORT|=data&0x0f;   //дλ
  LCD_en_write();
*/
  
}


void LCD_set_xy( unsigned char x, unsigned char y )  //дַ
{
    unsigned char address;
    if (y == 0) address = 0x80 + x;
    else   address = 0xc0 + x;
    LCD_write_command( address);
}
  
void LCD_write_string(unsigned char X,unsigned char Y,unsigned char *s) //x=0~15,y=0,1
{
    LCD_set_xy( X, Y ); //дַ    
    while (*s)  // дʾַ
    {
      LCD_write_data( *s );
      s ++;
    }
      
}

void LCD_write_char(unsigned char X,unsigned char Y,unsigned char data) //x=0~15,y=0,1
{
  LCD_set_xy( X, Y ); //дַ
  LCD_write_data( data);
  
}

